(function() {
    function createIframe(iframeHTML, width, height) {
        var iframe = document.createElement("iframe");

        var blob = new Blob([iframeHTML], {type: "text/html"});

        iframe.src = window.URL.createObjectURL(blob);
        iframe.className = "ecover_ui_iframe";
        iframe.style.width = width;
        iframe.style.height = height;
        iframe.style.borderRadius = "4px";
        iframe.style.border = "1px solid #c3c4c7";
        iframe.style.backgroundColor = "white";

        return iframe
    }


    document.addEventListener('DOMContentLoaded', function(){
        var form = document.querySelector('form#post');

        var configInput = form.querySelector('input[name=config]');

        var pluginContainer = document.getElementById("ecover_ui_iframe_wrap");

        // crear un handshake?
        // Otra posibilidad seria añadirlo en un contenedor con un cierto ID una vez la pagina esta cargada.

        var config = PLUGIN_DATA["config"];

        if (config)
            configInput.value = JSON.stringify(config);

        var rpc = RPC(window, {
            updateInputs: function(inputData){
                configInput.value = JSON.stringify(inputData.config);
            },
            config: function(cb){
                cb(config);
            },
            createPopup: function(cb){
    
            },
            openMediaGallery: function(cb){
                var custom_uploader = wp.media({
                    title: 'Select or upload image',
                    button: {
                        text: 'Set image'
                    },
                    multiple: false
                })
                .on('select', function() {
                    var attachment = custom_uploader.state().get('selection').first().toJSON();
                    cb(attachment.url)
                })
                .open();
            }
        });

        var iframe = createIframe(PLUGIN_DATA["iframe_html"], PLUGIN_DATA["iframe_width"], PLUGIN_DATA["iframe_height"]);
        pluginContainer.appendChild(iframe);
    }, false);
})();
