function initPlugin(plugin){

}

var EcoverBuilder = (function($, global) {
    // function onChangeParam

    var DEFAULT_WIDTH = 300;

    function isNullOrUndefined(value){
        return value === null || typeof value === "undefined";
    }

    function center(element) {
        return $(element).each(function() {
            var $this = $(this);
            var $parentThis = $this.parent();

            var top = ($parentThis.height() - $this.outerHeight()) / 2;
            var left = ($parentThis.width() - $(this).outerWidth()) / 2;
            $this.css({position:'absolute', top: (top > 0 ? top : 0)+'px', left: (left > 0 ? left : 0)+'px'});
        });
    }; 


    $.fn.centerMe = function () {
        this.css('left', Math.max($(window).width()/2 - $(this).width()/2, 0));
        this.css('top', Math.max($(window).height()/2 - $(this).height()/2, 0));
    };


    function readFileInput(input, onLoad) {

        if (input.files && input.files[0]) {
            var reader = new FileReader();

            reader.onload = function(e){
                onLoad(e.$point.result);
            }
            reader.readAsDataURL(input.files[0]);
        }
    }


    function absolutePath(href) {
        var link = document.createElement("a");
        link.href = href;
        return link.href;
    }

    /*

    function mediaGalleryOpenner(element, callback){
        element.click(function(e){
            e.preventDefault();
            var custom_uploader = wp.media({
                title: 'Select or upload image',
                button: {
                    text: 'Set image'
                },
                multiple: false
            })
            .on('select', function() {
                var attachment = custom_uploader.state().get('selection').first().toJSON();
                callback(attachment.url)
            })
            .open();
        });
    }

    mediaGalleryOpenner($el.find(".select_mockup.media_gallery"), setMockup)
    mediaGalleryOpenner($el.find(".select_cover.media_gallery"), setCover)


    var this._$mockupGallery = $('#mockupDialog select.image-picker');



    var _original_tb_show = tb_show;

    tb_show = function(){
        _original_tb_show.apply(null, arguments);

        $('#TB_window select.image-picker').imagepicker();
        jQuery(document).bind('keydown.thickbox', function(e){
            if(e.which == 13) {
                onSelectMockup()
           }
        });
    }
    */


    function EcoverBuilder(el, api, config){
        if (!(this instanceof EcoverBuilder)) return new EcoverBuilder(el, api, config);

        var self = this;

        var $el = $(el);

        this.$el = $el;
        this._mockupRatio = null;
        this._isHidden = false;

        this._isCoverInitialized = false;
        this._isMockupInitialized = false;

        this._isMovingCoverCorner = false;

        this._$cover = $el.find('.cover');
        this._$coverImg = this._$cover.find(".img");
        this._$coverPoints = this._$cover.find(".pt");

        this._$mockupWidth = $el.find('input[name=mockup_width]');

        this._$mockup = $el.find('.mockup_img');

        this._api = api;

        this.$el.on('dblclick', '#page-mockup_gallery ul.image_picker_selector img', this._onSelectMockup.bind(this))
        this.$el.on('click', '#page-mockup_gallery button.submit', this._onSelectMockup.bind(this))

        var $mockupSelect = $el.find('[data-page="mockup_gallery"] select.image-picker');

        MOCKUP_IMAGE_URLS.forEach(function(mockupUrl, i){
            $mockupSelect.append($('<option>', {
                value: absolutePath(mockupUrl),
                text:'Mockup '+ (i + 1),
                data: {
                    'img-src': mockupUrl,
                    'img-class': 'mockup-gallery-img'
                }
            }));
        });

        $mockupSelect.imagepicker();

        $(document).bind('keydown', function(e){
            if (PageTransitions.currentPageName()== "mockup_gallery"){
                if(e.which == 13) {
                    e.preventDefault();
                    self._onSelectMockup()

                } else if(e.which == 27){
                    
                    PageTransitions.setPage("main");
                }
            }
        });

        $el.find(".mockup_selection.media_gallery").click(function(e){
            e.preventDefault();

            api.openMediaGallery(self._setMockup.bind(self));
        });


        $el.find(".cover_selection.media_gallery").click(function(e){
            e.preventDefault();

            api.openMediaGallery(self._setCover.bind(self));
        });

        this._$mockupWidth.on('keypress', function(e) {
            if(e.which == 13) {
                e.preventDefault();
                self._updateMockupWidth($(this).val());
            }
        });

        $el.find("button.change_width").click(function(e){
            e.preventDefault();

            var width = self._$mockupWidth.val();
            self._updateMockupWidth(width);
        })

        $el.find("#show_demo").click(function(e){
            e.preventDefault();

            if (isNullOrUndefined(config.mockup)){
                alert("Select a mockup");
                return;
            }

            if (isNullOrUndefined(config.cover)){
                alert("Select a cover");
                return;
            }

            window.open().document.body.innerHTML = EcoverBuilder.render(config);
        });

        if (config){
            if (config.cover) {
                var url = config.cover.src; 

                this._setCover(url, config.cover);
            }

            if (config.mockup) {
                var url = config.mockup.src; 

                this._setMockup(url, config.mockup);
            } else {
                this._$mockupWidth.val(DEFAULT_WIDTH);
            }
        }

    }

    EcoverBuilder.prototype._onSelectMockup = function(){
        
        var url = $('#page-mockup_gallery select.image-picker').val();

        this._setMockup(url);

        PageTransitions.setPage("main");
    }

    EcoverBuilder.prototype._calculateRelativeDistance = function(){
        var dx = this._$cover.offset().left - this._$mockup.offset().left;
        var dy = this._$cover.offset().top - this._$mockup.offset().top;
        
        return {
            dx: dx,
            dy: dy
        }
    }

    EcoverBuilder.prototype._setMockup = function(url, initData) {
        var self = this;

        var tmpImg = new Image();

        tmpImg.onload = function() {
            var mockupWidth, mockupHeight;

            self._mockupRatio = this.height / this.width;

            initData = initData || {};

            if (!self._isMockupInitialized){
                self._isMockupInitialized = true;

                self._$mockup.show();

                self._$mockup.myDraggable({
                    stop: function(e){
                        var left = parseInt(self._$mockup.css("left"));
                        self._api.setConfigParam("mockup.x", left);

                        var top = parseInt(self._$mockup.css("top"));                            
                        self._api.setConfigParam("mockup.y", top);


                        if (self._isCoverInitialized){
                            var distance = self._calculateRelativeDistance()
                            var dx = distance.dx;
                            self._api.setConfigParam("dx", dx);

                            var dy = distance.dy;                                
                            self._api.setConfigParam("dy", dy);
                        }
                    }
                });
            }

            self._api.setConfigParam("mockup.src", url);

            self._$mockup.attr('src', url);

            if (initData.width){
                mockupWidth = initData.width;
            } else {
                mockupWidth = self._$mockupWidth.val();
                mockupWidth = parseInt(mockupWidth) || DEFAULT_WIDTH;   
            }

            self._$mockupWidth.val(mockupWidth);
            self._api.setConfigParam("mockup.width", mockupWidth);

            mockupHeight = parseInt(mockupWidth * self._mockupRatio);

            self._$mockup.css('height', mockupHeight);
            self._api.setConfigParam("mockup.height", mockupHeight);

            var mockupX, mockupY;
            if (typeof initData.x !== "undefined" && typeof initData.y !== "undefined") {
                mockupY = initData.y;
                mockupX = initData.x;
            } else {
                mockupX = 0;
                mockupY = 0;
            }

            self._$mockup.css({
                top: mockupY,
                left: mockupX
            });

            self._api.setConfigParam("mockup.x", mockupX);
            self._api.setConfigParam("mockup.y", mockupY);

            if (self._isCoverInitialized){
                var distance = self._calculateRelativeDistance()

                self._api.setConfigParam("dx", distance.dx);
                self._api.setConfigParam("dy", distance.dy);
            }

        }
  
        tmpImg.src = url;
    }


    EcoverBuilder.prototype._setCover = function(url, initData) {
        var self = this;

        var tmpImg = new Image();

        tmpImg.onload = function() {
            var coverWidth, coverHeight;

            var coverRatio = this.height / this.width;

            initData = initData || {};
            

            if (!self._isCoverInitialized){
                self._isCoverInitialized = true;

                self._$cover.show();
                self._$cover.centerMe();

                self._$cover.myDraggable({
                    handle: ".img",
                    stop: function(){
                        var left = parseInt(self._$cover.css("left"));
                        self._api.setConfigParam("cover.x", left);

                        var top = parseInt(self._$cover.css("top"));
                        self._api.setConfigParam("cover.y", top);

                        if (self._isMockupInitialized){
                            var distance = self._calculateRelativeDistance()

                            var dx = distance.dx;
                            self._api.setConfigParam("dx", dx);

                            var dy = distance.dy;
                            self._api.setConfigParam("dy", dy);
                        }
                    }
                });
            }

            if (initData.width){
                coverWidth = initData.width;
            } else {
                coverWidth = Math.min(this.width, DEFAULT_WIDTH);
            }

            self._api.setConfigParam("cover.width", coverWidth);

            if (initData.height){
                coverHeight = initData.height;
            } else {
                coverHeight = parseInt(coverWidth * coverRatio);
            }

            self._api.setConfigParam("cover.height", coverHeight);

            self._$coverImg.css('background-image', 'url(' + url + ')');
            self._$coverImg.css('background-size', coverWidth + 'px ' + coverHeight + 'px');
            self._$coverImg.css('width', coverWidth);
            self._$coverImg.css('height', coverHeight);

            self._api.setConfigParam("cover.src", url);


            var coverX, coverY;
            if (typeof initData.x !== "undefined" && typeof initData.y !== "undefined") {
                coverY = initData.y;
                coverX = initData.x;
            } else {
               coverX = 0
               coverY = 0;
            }

            self._$cover.css({
                top: coverY,
                left: coverX
            });

            self._api.setConfigParam("cover.x", coverX);
            self._api.setConfigParam("cover.y", coverY);


            var transform = new PerspectiveTransform(self._$coverImg[0], parseFloat(coverWidth), parseFloat(coverHeight), true);

            function updateTransform(){
                // check the polygon error, if it's 0, which mean there is no error
                if(transform.checkError() == 0){
                    transform.update();

                    if (self._isHidden) {
                        self._isHidden = false;
                        self._$coverImg.show();
                    }

                    self._api.setConfigParam("cover.transform", self._$coverImg.css("transform"));
                } else {
                    if (!self._isHidden) {
                        self._isHidden = true;
                        self._$coverImg.hide();
                    }
                }
            }

            var corners;

            if (initData.corners && typeof initData.corners.topLeft.x !== "undefined" && typeof initData.corners.topLeft.y !== "undefined" && typeof initData.corners.topRight.x !== "undefined" && typeof initData.corners.topRight.y !== "undefined" && typeof initData.corners.bottomLeft.x !== "undefined" && typeof initData.corners.bottomLeft.y !== "undefined" && typeof initData.corners.bottomRight.x !== "undefined" && typeof initData.corners.bottomRight.y !== "undefined"){

                corners = initData.corners;
            } else {
                corners = {
                    topLeft: {
                        x: 20,
                        y: 20
                    },
                    topRight: {
                        x: 420,
                        y: 20
                    },
                    bottomLeft: {
                        x: 20,
                        y: 20+ Math.round(DEFAULT_WIDTH*coverRatio)
                    },
                    bottomRight: {
                        x: 420,
                        y: 20+Math.round(DEFAULT_WIDTH*coverRatio)
                    }
                }
            }


            ["topLeft", "topRight", "bottomLeft", "bottomRight"].forEach(function(coordinateName){
                ["x", "y"].forEach(function(axis){
                    var coordValue = corners[coordinateName][axis];

                    transform[coordinateName][axis] = coordValue;


                    self._api.setConfigParam("cover.corners." + coordinateName + "." + axis, coordValue);
                });
            });

            updateTransform();

            self._$coverPoints.filter(".tl").css({
                left : transform.topLeft.x + "px",
                top : transform.topLeft.y + "px"
            });

            self._$coverPoints.filter(".tr").css({
                left : transform.topRight.x + "px",
                top : transform.topRight.y + "px"
            });

            self._$coverPoints.filter(".bl").css({
                left : transform.bottomLeft.x + "px",
                top : transform.bottomLeft.y + "px"
            });

            self._$coverPoints.filter(".br").css({
                left : transform.bottomRight.x + "px",
                top : transform.bottomRight.y + "px"
            });

            var $point;
            var transformCornerPosition;
            var dragDx, dragDy;
            var $cornerX, $cornerY;
            var cornerPos;
            var x, y;


            self._$coverPoints.each(function(inddex, point){
                var $point = $(point);

                $point.myDraggable({
                    start: function(e){
                        if ($point.hasClass("tl")) {
                            cornerPos = 'topLeft';
                        } else if ($point.hasClass("tr")) {
                            cornerPos = 'topRight';
                        } else if ($point.hasClass("bl")) {
                            cornerPos = 'bottomLeft';
                        } else {
                            cornerPos = 'bottomRight';
                        }

                        transformCornerPosition = transform[cornerPos];

                        dragDy = $point.offset().top + 20 - e.pageY;
                        dragDx = $point.offset().left + 20 - e.pageX;
                    },
                    drag: function(e){
                        // var left =  $point.css("left"); x = parseInt(left.substring(0, left.length-2))
                        x = (e.pageX + dragDx) - self._$cover.offset().left;

                        // var top =  $point.css("top"); x = parseInt(left.substring(0, top.length-2))
                        y = (e.pageY + dragDy) - self._$cover.offset().top;

                        transformCornerPosition.x = x;
                        transformCornerPosition.y = y;


                        updateTransform();
                    },
                    stop: function(e){
                        self._api.setConfigParam("cover.corners." + cornerPos + ".x", x);
                        self._api.setConfigParam("cover.corners." + cornerPos + ".y", y);
                    }
                });
            });

            self._isHidden = false;


            if (self._isMockupInitialized){
                var distance = self._calculateRelativeDistance()

                self._api.setConfigParam("dx", distance.dx);
                self._api.setConfigParam("dy", distance.dy);
            }

        }

        tmpImg.src = url;
    }

    EcoverBuilder.prototype._updateMockupWidth = function(width){
        if (this._$mockup){
            width = parseInt(width);

            if(!isNaN(width)) {
                var height = parseInt(width * this._mockupRatio);

                this._api.setConfigParam("mockup.width", width);
                this._api.setConfigParam("mockup.height", height);

                this._$mockup.css('width', width);
                this._$mockup.css('height', height);
            }
        } else {
            alert("Not selected yet any mockup image")
        }
    }


    EcoverBuilder.createBook = function(config){
        var $book = $('<div class="ecover"><div class="mockup"><div class="cover"></div></div></div>');

        var coverTransform = config.cover.transform;
        var coverBackgroundImage = config.cover.src;
        var coverWidth = config.cover.width;
        var coverHeight = config.cover.height;
        var mockupSrc = config.mockup.src;
        var mockupWith = config.mockup.width;
        var mockupHeight = config.mockup.height;
        var dx = config.dx;
        var dy = config.dy;

        // var dx = this._$cover.offset().left- this._$mockup.offset().left;
        // var dy = this._$cover.offset().top - this._$mockup.offset().top;

        var $bookMockup = $book.find(".mockup");
        var $cover = $book.find(".cover");

        $bookMockup.css("width", mockupWith+"px")
        $bookMockup.css("height", mockupHeight+"px");
        $bookMockup.css("padding", 0);

        var mockupBackgroundCSS = "url(" + mockupSrc+ ")" + " top left / cover no-repeat ";
        $bookMockup.css("background", mockupBackgroundCSS)
        $cover.css("background-image", "url("+coverBackgroundImage+")");

        $cover.css("width", coverWidth+"px");
        $cover.css("height", coverHeight+"px");
        $cover.css("transform", coverTransform);

        $cover.css("position", "relative");
        $cover.css("top", dy);
        $cover.css("left", dx);

        return $book;
    }

    EcoverBuilder.createBook2 = function(container, mockupSrc, mockupWith, mockupHeight, coverSrc, coverWidth, coverHeight, coverCoordinates){
        var $container = $(container);
        $container.html("<div class='book_mockup'><div class='cover'></div></div>");

        var $bookMockup = $container.find(".book_mockup");
        var $cover = $container.find(".cover");

        $bookMockup.css("width", mockupWith)
        $bookMockup.css("height", mockupHeight);

        var mockupBackgroundCSS = "url(" + mockupSrc+ ")" + " top left / cover no-repeat ";
        $bookMockup.css("background", mockupBackgroundCSS)

        $cover.css("background-image", "url(" + coverSrc + ")");
        $cover.css("width", coverWidth);
        $cover.css("height", coverHeight);


        var offsetX = 0 //coverWidth / 2.0;
        var offsetY = 0 //coverHeight / 2.0;

        var sourcePoints = PerspectiveTransform.translate([
            [0,0],
            [coverWidth, 0],
            [0, coverHeight],
            [coverWidth, coverHeight]
        ],  -offsetX, -offsetY);

        var transformCorners = PerspectiveTransform.translate(coverCoordinates, -offsetX, -offsetY);

        var matrix3D = PerspectiveTransform.matrix3d(sourcePoints, transformCorners);
        $cover.css("transform-origin", "0 0");
        $cover.css("transform", "matrix3d(" + matrix3D + ")");
    }

    EcoverBuilder.render = function(config){
        if (isNullOrUndefined(config.cover) || isNullOrUndefined(config.mockup) || isNullOrUndefined(config.dx) || isNullOrUndefined(config.dy)) return "";

        var coverTransform = config.cover.transform;
        var coverBackgroundImage = config.cover.src;
        var coverWidth = config.cover.width;
        var coverHeight = config.cover.height;
        var mockupSrc = config.mockup.src;
        var mockupWidth = config.mockup.width;
        var mockupHeight = config.mockup.height;
        var dx = config.dx;
        var dy = config.dy;

        // var dx = this._$cover.offset().left- this._$mockup.offset().left;
        //var dy = this._$cover.offset().top - this._$mockup.offset().top;

        // Añadir ecover-$id
        var html = '<div class="ecover">';

        html += '<div class="mockup" style="';
        html += 'width:'+ mockupWidth + 'px;';
        html += 'height:'+ mockupHeight + 'px;';
        html += 'background:url(' + encodeURI(mockupSrc) + ')' + ' top left / cover no-repeat;';
        html += 'padding:0">';

        html += '<div class="cover" style="';
        html += 'width:'+ coverWidth + 'px;';
        html += 'height:'+ coverHeight + 'px;';
        html += 'top:' + dy + 'px;';
        html += 'left:' + dx + 'px;';
        html += 'transform:' + coverTransform + ';';
        html += 'background-image:url(' + encodeURI(coverBackgroundImage) + ');';
        html += 'background-size:' + coverWidth + 'px ' + coverHeight + 'px;'
        html += 'position: relative">';
        html += '</div>';
        html += '</div>';
        html += '</div>';

        return html;
    }

    EcoverBuilder.render2 = function(config){
        var $book = EcoverBuilder.createBook(config);
        return $book.html();
    }


    var ecoverBuilder = null;

    EcoverBuilder.getInstance = function(){
        return ecoverBuilder;
    }

    EcoverBuilder.init = function(){
        if (ecoverBuilder !== null) throw "Ecover builder already initialized";

        var rpc = RPC(window.parent);
        rpc.call("config", function(_config){
             config = _config || {};

             var el = document.body;
             ecoverBuilder = EcoverBuilder(el, api, config)
        });

        var timeoutId = null;
        var config = null;

        var updateInputs = function(){
            timeoutId = null;
            rpc.call("updateInputs", {
                config: config,
            });
        }


        var api = {
            setConfigParam: function(paramName, paramValue){
                if (config === null) {
                    throw "Initialization not yet finnished"
                }
                var paramNameParts = paramName.split(".");

                obj = config;
                paramNameParts.splice(0, paramNameParts.length-1).forEach(function(paramNamePart){
                    if (typeof obj[paramNamePart] == "undefined") obj[paramNamePart] = {}
                    obj = obj[paramNamePart];
                });

                obj[paramNameParts[paramNameParts.length-1]] = paramValue;


                if (timeoutId) clearTimeout(timeoutId);
                timeoutId = setTimeout(updateInputs, 300);
            },
            openMediaGallery: function(cb){
                rpc.call("openMediaGallery", cb);
            }
        }
    }

    return EcoverBuilder;

})(jQuery, window);

